-- Collection of miscellaneous helper functions

-- Prints the text if debug is set to true
function DebugPrint(...)
   if debug then
      print("DEBUG: ", ...)
   end 
end


-- Executes the provided function if debug is set to true
function DebugFunction(func)
   if debug then
      func()
   end
end

function CopyTable(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[CopyTable(orig_key)] = CopyTable(orig_value)
        end
        setmetatable(copy, CopyTable(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end